#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

double *allocate_array(int n){
	double *a;
	a=(double*)malloc((unsigned)n*sizeof(double));
	return a;
	}


int main(int argc, char *argv[]){
	int brtacaka =0;
	int rank;
	int size;
	int i,j,k,l;
	double x1Max,y1Max,x2Max,y2Max,x3Max,y3Max,x4Max,y4Max;
	double povrsinaMax=0;
	double najvecaOdSvih=0;
	double *x;
	double *y;
	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	
	if(rank == 0){
		scanf("%d",&brtacaka);
		x=allocate_array(brtacaka);
		y=allocate_array(brtacaka);
		for(i=0;i<brtacaka;i++){
			scanf("%lf %lf",&x[i],&y[i]);
			}
		}
	
	MPI_Barrier(MPI_COMM_WORLD);
	MPI_Bcast(&brtacaka,1,MPI_INT,0,MPI_COMM_WORLD);
	if(rank != 0){
		x=allocate_array(brtacaka);
		y=allocate_array(brtacaka);
		}
	MPI_Bcast(x,brtacaka,MPI_DOUBLE,0,MPI_COMM_WORLD);
	MPI_Bcast(y,brtacaka,MPI_DOUBLE,0,MPI_COMM_WORLD);
	
	/*
	if(rank == 1){
		for(i=0;i<brtacaka;i+=2){
			printf("%d\n",i);
			}
		} */ 
		
	for(i=rank;i<brtacaka;i+=size){
		for(j=i+1;j<brtacaka;j++){
			for(l=j+1;l<brtacaka;l++){
				for(k=l+1;k<brtacaka;k++){
					double trenutnaPovrsina=(y[i]*(x[k]-x[j])+y[j]*(x[i]-x[l])+y[l]*(x[j]-x[k])+y[k]*(x[l]-x[i]));
						if(povrsinaMax < trenutnaPovrsina){
								povrsinaMax=trenutnaPovrsina;
								x1Max=x[i];
								y1Max=y[i];
								x2Max=x[j];
								y2Max=y[j];
								x3Max=x[l];
								y3Max=y[l];
								x4Max=x[k];
								y4Max=y[k];
							}
							//printf("k je:%d\n",k);
					}
				}
			}
		}
	
	MPI_Reduce(&povrsinaMax,&najvecaOdSvih,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD);
	MPI_Bcast(&najvecaOdSvih,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
	if(povrsinaMax == najvecaOdSvih){
		printf("Povrsina je: %lf a tacke su :\n x1: %lf y1: %lf\n x2: %lf y2: %lf\n x3: %lf y3: %lf\n x4: %lf y4: %lf\n",povrsinaMax,x1Max,y1Max,x2Max,y2Max,x3Max,y3Max,x4Max,y4Max);
		}
	
		MPI_Finalize();
		return 0;
	}
