#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>

float Povrsina(x1,x2,x3,x4,y1,y2,y3,y4){
	float p = 0.5*(y1*(x4-x2)+y2*(x1-x3)+y3*(x2-x4)+y4*(x3-x1));
	if(p<0)
		return p*-1;
	return p;	
}

main(int argc, char **argv){
	
	system("clear");
	
	int id,p;
	int i1,i2,i3,i4,j1,j2,j3,j4;
	
	MPI_Status status;
	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD,&id);
	MPI_Comm_size(MPI_COMM_WORLD,&p);
	
	int n,i;
	int *x,*y;

	if(id==0){
		scanf("%d",&n);
		x = (int*)malloc(n*sizeof(int));
		y = (int*)malloc(n*sizeof(int));
		for(i=0;i<n;i++)
			scanf("%d%d",&x[i],&y[i]);
	}
	
	int div = n/p;
	
	MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
	if(id!=0){
		x = (int*)malloc(n*sizeof(int));
		y = (int*)malloc(n*sizeof(int));
	}
	MPI_Bcast(x,n,MPI_INT,0,MPI_COMM_WORLD);	
	MPI_Bcast(y,n,MPI_INT,0,MPI_COMM_WORLD);	
	
	
	float tmp = 0;
	float povrsina;
	
	int cnt = 0;

	int tx[8];
	
	for(i1=id;i1<n;i1+=p){		
		//printf("%d\n",i1);
		for(i2=i1+1;i2<n;i2++){
			for(i3=i2+1;i3<n;i3++){
				for(i4=i3+1;i4<n;i4++){
					povrsina = Povrsina(x[i1],x[i2],x[i3],x[i4],y[i1],y[i2],y[i3],y[i4]);
					if(povrsina!=0){
						cnt++;
						if(povrsina>tmp){
							tmp = povrsina;
							tx[0] = x[i1];
							tx[1] = x[i2];
							tx[2] = x[i3];
							tx[3] = x[i4];
							tx[4] = y[i1];
							tx[5] = y[i2];
							tx[6] = y[i3];
							tx[7] = y[i4];
						}							
					}
				}
			}
		}
	}	

	float max;
	MPI_Allreduce(&tmp,&max,1,MPI_FLOAT,MPI_MAX,MPI_COMM_WORLD);
	
	if(tmp==max){
		printf("najveca povrsina: %.2f\n",max);
		for(i=0;i<8;i+=2)
			printf("A(%d,%d)\n",tx[i],tx[i+1]);
	}
	
	
	MPI_Finalize();
	
}
