#include <boost/serialization/access.hpp>
#include <sstream>
#include <boost/serialization/string.hpp>
#include <iostream>
#include <string.h>

class Kosarkas{
	public:
		int id;
		char ime[50];
		int br_poena;
		int br_asistencija;
		int br_skokova;
		int br_utakmica;
		//vector<Stat> rezultat;
	public:
		Kosarkas();
		Kosarkas(int id, char* ime);
		void AddStat(int br_poena,int br_asistencija,int br_skokova);
		bool isPlayer(int id);
		bool operator>(const Kosarkas &k);
		friend class boost::serialization::access;
		template<class Archive>
		void serialize(Archive ar,const unsigned int version){
			ar & id;
			ar & ime;
			ar & br_poena;
			ar & br_asistencija;
			ar & br_skokova;
			ar & br_utakmica;
		}
};
